#define _CRT_SECURE_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include "FileLib.h"

//------------------------------------------------------------------
//  ChangeFileExtension       1999/3/1
//    gqύX(Extend͐擪ɃsIh܂ޕ)
//------------------------------------------------------------------
BOOL ChangeFileExtension(LPSTR DstFile, LPCSTR SrcFile, LPCSTR Extend)
{
	size_t len;
	const char *ptr;
	char path[MAX_PATH];

	len = strlen(SrcFile);
	memcpy(path, SrcFile, len+1);
	for(ptr=&path[len]; ptr>path; )
	{
		ptr = CharPrevA(path, ptr);
		if(*ptr == '.') {
			strcpy(DstFile, path);
			strcpy(&DstFile[(unsigned)(ptr-path)], Extend);
			return TRUE;
		}
		if(*ptr=='\\' || *ptr=='/'){
			strcpy(DstFile, path);
			strcpy(&DstFile[len], Extend);
			return TRUE;
		}
	}
	// not find either period or \, so add extension
	strcpy(DstFile, path);
	strcpy(&DstFile[len], Extend);
	return TRUE;
}	//ChangeFileExtension()

BOOL ChangeFileExtension(LPWSTR DstFile, LPCWSTR SrcFile, LPCWSTR Extend)
{
	size_t len;
	const wchar_t *ptr;
	wchar_t path[MAX_PATH];

	len = wcslen(SrcFile);
	memcpy(path, SrcFile, sizeof(wchar_t)*(len+1));
	for(ptr=&path[len]; ptr>path; )
	{
		ptr = CharPrevW(path, ptr);
		if(*ptr == L'.') {
			wcscpy(DstFile, path);
			wcscpy(&DstFile[(size_t)(ptr-path)], Extend);
			return TRUE;
		}
		if(*ptr==L'\\' || *ptr==L'/'){
			wcscpy(DstFile, path);
			wcscpy(&DstFile[len], Extend);
			return TRUE;
		}
	}
	// not find either period or \, so add extension
	wcscpy(DstFile, path);
	wcscpy(&DstFile[len], Extend);
	return TRUE;
}	//ChangeFileExtension()

//------------------------------------------------------------------
//  GetFileExtension       1999/3/1
//    pXgqo
//------------------------------------------------------------------
BOOL GetFileExtension(LPSTR DstFile, LPCSTR SrcFile)
{
	size_t len;
	const char *ptr;
	char path[MAX_PATH];

	len = strlen(SrcFile);
	memcpy(path, SrcFile, len+1);
	for(ptr=&path[len]; ptr>path; )
	{
		ptr = CharPrevA(path, ptr);
		if(*ptr == '.') {
			strcpy(DstFile, ptr+1);
			return TRUE;
		}
		if(*ptr=='\\' || *ptr=='/')
			break;
	}
	DstFile[0] = 0;
	return TRUE;
}	//GetFileExtension()

BOOL GetFileExtension(LPWSTR DstFile, LPCWSTR SrcFile)
{
	size_t len;
	const wchar_t *ptr;
	wchar_t path[MAX_PATH];

	len = wcslen(SrcFile);
	memcpy(path, SrcFile, sizeof(wchar_t)*(len+1));
	for(ptr=&path[len]; ptr>path; )
	{
		ptr = CharPrevW(path, ptr);
		if(*ptr == L'.') {
			wcscpy(DstFile, ptr+1);
			return TRUE;
		}
		if(*ptr==L'\\' || *ptr==L'/')
			break;
	}
	DstFile[0] = 0;
	return TRUE;
}	//GetFileExtension()

//------------------------------------------------------------------
//  GetFileNameFromPath       1999/3/1
//    pXt@C(gq)o
//------------------------------------------------------------------
BOOL GetFileNameFromPath(LPSTR DstFile, LPCSTR SrcFile)
{
	size_t len;
	const char *ptr, *endptr;
	char path[MAX_PATH];

	len = strlen(SrcFile);
	memcpy(path, SrcFile, len+1);
	endptr = &path[len];
	for(ptr=endptr; ptr>path; )
	{
		ptr = CharPrevA(path, ptr);
		if(*ptr == '.' && endptr == &path[len])
			endptr = ptr;
		if(*ptr=='\\' || *ptr=='/'){
			ptr = CharNextA(ptr);
			break;
		}
	}
	if(ptr >= endptr)
		return FALSE;
	memcpy(DstFile, ptr, (int)(endptr-ptr));
	DstFile[(unsigned)(endptr-ptr)] = 0;
	return TRUE;
}	//GetFileNameFromPath()

BOOL GetFileNameFromPath(LPWSTR DstFile, LPCWSTR SrcFile)
{
	size_t len;
	const wchar_t *ptr, *endptr;
	wchar_t path[MAX_PATH];

	len = wcslen(SrcFile);
	memcpy(path, SrcFile, sizeof(wchar_t)*(len+1));
	endptr = &path[len];
	for(ptr=endptr; ptr>path; )
	{
		ptr = CharPrevW(path, ptr);
		if(*ptr == L'.' && endptr == &path[len])
			endptr = ptr;
		if(*ptr==L'\\' || *ptr==L'/'){
			ptr = CharNextW(ptr);
			break;
		}
	}
	if(ptr >= endptr)
		return FALSE;
	memcpy(DstFile, ptr, sizeof(wchar_t)*(size_t)(endptr-ptr));
	DstFile[(size_t)(endptr-ptr)] = 0;
	return TRUE;
}	//GetFileNameFromPath()

//------------------------------------------------------------------
//  GetFolderFromPath   1999/3/1
//    pXtH_(I[ɕK\܂)݂̂o
//------------------------------------------------------------------
BOOL GetFolderFromPath(LPSTR DstPath, LPCSTR FileName)
{
	size_t len;
	const char *ptr;
	char path[MAX_PATH];

	len = strlen(FileName);
	memcpy(path, FileName, len+1);
	for(ptr=&path[len]; ptr>path; )
	{
		ptr = CharPrevA(path, ptr);
		if(*ptr=='\\' || *ptr=='/'){
			memcpy(DstPath, path, (int)(ptr-path));
			if(DstPath[(unsigned)(ptr-path)-1] != '\\'
			&& DstPath[(unsigned)(ptr-path)-1] != '/'){
				DstPath[(unsigned)(ptr-path)] = '\\';
				DstPath[(unsigned)(ptr-path)+1] = 0;
			} else
				DstPath[(unsigned)(ptr-path)] = 0;
			return TRUE;
		}
	}
	return FALSE;
}	//GetFolderFromPath()

BOOL GetFolderFromPath(LPWSTR DstPath, LPCWSTR FileName)
{
	size_t len;
	const wchar_t *ptr;
	wchar_t path[MAX_PATH];

	len = wcslen(FileName);
	memcpy(path, FileName, sizeof(wchar_t)*(len+1));
	for(ptr=&path[len]; ptr>path; )
	{
		ptr = CharPrevW(path, ptr);
		if(*ptr==L'\\' || *ptr==L'/'){
			memcpy(DstPath, path, sizeof(wchar_t)*(size_t)(ptr-path));
			if(DstPath[(size_t)(ptr-path)-1] != L'\\'
			&& DstPath[(size_t)(ptr-path)-1] != L'/'){
				DstPath[(size_t)(ptr-path)] = L'\\';
				DstPath[(size_t)(ptr-path)+1] = 0;
			} else
				DstPath[(size_t)(ptr-path)] = 0;
			return TRUE;
		}
	}
	return FALSE;
}	//GetFolderFromPath()

//------------------------------------------------------------------
//  GetFileNameAndExt   1999/3/1
//    pXt@CƊgqo
//------------------------------------------------------------------
BOOL GetFileNameAndExt(LPSTR DstFile, LPCSTR FileName)
{
	size_t len;
	const char *ptr, *endptr;
	char path[MAX_PATH];

	len = strlen(FileName);
	memcpy(path, FileName, len+1);
	endptr = &path[len];
	for(ptr=endptr; ptr>path; )
	{
		ptr = CharPrevA(path, ptr);
		if(*ptr=='\\' || *ptr=='/'){
			ptr = CharNextA(ptr);
			break;
		}
	}
	if(ptr >= endptr)
		return FALSE;
	strcpy(DstFile, ptr);
	return TRUE;
}	//GetFileNameAndExt()

BOOL GetFileNameAndExt(LPWSTR DstFile, LPCWSTR FileName)
{
	size_t len;
	const wchar_t *ptr, *endptr;
	wchar_t path[MAX_PATH];

	len = wcslen(FileName);
	memcpy(path, FileName, sizeof(wchar_t)*(len+1));
	endptr = &path[len];
	for(ptr=endptr; ptr>path; )
	{
		ptr = CharPrevW(path, ptr);
		if(*ptr==L'\\' || *ptr==L'/'){
			ptr = CharNextW(ptr);
			break;
		}
	}
	if(ptr >= endptr)
		return FALSE;
	wcscpy(DstFile, ptr);
	return TRUE;
}	//GetFileNameAndExt()

//------------------------------------------------------------------
//  GetUpFolder   1999/9/9
//    ̃tH_(I[\܂)𓾂B
//------------------------------------------------------------------
BOOL GetUpFolder(LPSTR DstPath, LPCSTR SrcPath)
{
	size_t len;
	const char *ptr, *endptr;

	len = strlen(SrcPath);
	if(len == 0)
		return FALSE;
	endptr = &SrcPath[len];
	ptr = CharPrevA(SrcPath, endptr);
	if(*ptr == '\\' || *ptr=='/')
		ptr = CharPrevA(SrcPath, ptr);
	for(; ptr>SrcPath; ptr=CharPrevA(SrcPath,ptr))
	{
		if(*ptr=='\\' || *ptr=='/') {
			len = (int)(ptr - SrcPath) + 1;
			memcpy(DstPath, SrcPath, len);
			DstPath[len] = 0;
			return TRUE;
		}
	}
	return FALSE;
}

BOOL GetUpFolder(LPWSTR DstPath, LPCWSTR SrcPath)
{
	size_t len;
	const wchar_t *ptr, *endptr;

	len = wcslen(SrcPath);
	if(len == 0)
		return FALSE;
	endptr = &SrcPath[len];
	ptr = CharPrevW(SrcPath, endptr);
	if(*ptr == L'\\' || *ptr==L'/')
		ptr = CharPrevW(SrcPath, ptr);
	for(; ptr>SrcPath; ptr=CharPrevW(SrcPath,ptr))
	{
		if(*ptr==L'\\' || *ptr==L'/') {
			len = (int)(ptr - SrcPath) + 1;
			memcpy(DstPath, SrcPath, sizeof(wchar_t)*len);
			DstPath[len] = 0;
			return TRUE;
		}
	}
	return FALSE;
}


